#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscdm.h>
#include <petscdmda.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define dmdaglobaltonaturalbegin_ DMDAGLOBALTONATURALBEGIN
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define dmdaglobaltonaturalbegin_ dmdaglobaltonaturalbegin
#endif
PETSC_EXTERN void dmdaglobaltonaturalbegin_(DM *a, Vec *b, InsertMode *c, Vec *d, PetscErrorCode *ierr)
{
  *ierr = DMDAGlobalToNaturalBegin(*a, *b, *c, *d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscdm.h>
#include <petscdmda.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define dmdaglobaltonaturalend_ DMDAGLOBALTONATURALEND
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define dmdaglobaltonaturalend_ dmdaglobaltonaturalend
#endif
PETSC_EXTERN void dmdaglobaltonaturalend_(DM *a, Vec *b, InsertMode *c, Vec *d, PetscErrorCode *ierr)
{
  *ierr = DMDAGlobalToNaturalEnd(*a, *b, *c, *d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscdm.h>
#include <petscdmda.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define dmdanaturaltoglobalbegin_ DMDANATURALTOGLOBALBEGIN
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define dmdanaturaltoglobalbegin_ dmdanaturaltoglobalbegin
#endif
PETSC_EXTERN void dmdanaturaltoglobalbegin_(DM *a, Vec *b, InsertMode *c, Vec *d, PetscErrorCode *ierr)
{
  *ierr = DMDANaturalToGlobalBegin(*a, *b, *c, *d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscdm.h>
#include <petscdmda.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define dmdanaturaltoglobalend_ DMDANATURALTOGLOBALEND
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define dmdanaturaltoglobalend_ dmdanaturaltoglobalend
#endif
PETSC_EXTERN void dmdanaturaltoglobalend_(DM *a, Vec *b, InsertMode *c, Vec *d, PetscErrorCode *ierr)
{
  *ierr = DMDANaturalToGlobalEnd(*a, *b, *c, *d);
  if (*ierr) return;
}
