#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscdm.h>
#include <petscdmfield.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define dmfieldshellgetcontext_ DMFIELDSHELLGETCONTEXT
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define dmfieldshellgetcontext_ dmfieldshellgetcontext
#endif
PETSC_EXTERN void dmfieldshellgetcontext_(DMField *a, void *b, PetscErrorCode *ierr)
{
  *ierr = DMFieldShellGetContext(*a, b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscdm.h>
#include <petscdmfield.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define dmfieldshellevaluatefedefault_ DMFIELDSHELLEVALUATEFEDEFAULT
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define dmfieldshellevaluatefedefault_ dmfieldshellevaluatefedefault
#endif
PETSC_EXTERN void dmfieldshellevaluatefedefault_(DMField *a, IS *b, PetscQuadrature *c, PetscDataType *d, void *e, void *f, void *g, PetscErrorCode *ierr)
{
  *ierr = DMFieldShellEvaluateFEDefault(*a, *b, *c, *d, e, f, g);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscdm.h>
#include <petscdmfield.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define dmfieldshellevaluatefvdefault_ DMFIELDSHELLEVALUATEFVDEFAULT
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define dmfieldshellevaluatefvdefault_ dmfieldshellevaluatefvdefault
#endif
PETSC_EXTERN void dmfieldshellevaluatefvdefault_(DMField *a, IS *b, PetscDataType *c, void *d, void *e, void *f, PetscErrorCode *ierr)
{
  *ierr = DMFieldShellEvaluateFVDefault(*a, *b, *c, d, e, f);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscdm.h>
#include <petscdmfield.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define dmfieldcreateshell_ DMFIELDCREATESHELL
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define dmfieldcreateshell_ dmfieldcreateshell
#endif
PETSC_EXTERN void dmfieldcreateshell_(DM *a, PetscInt *b, DMFieldContinuity *c, void *d, DMField *e, PetscErrorCode *ierr)
{
  PetscBool null_e = !*(void**) e ? PETSC_TRUE : PETSC_FALSE;
  CHKFORTRANNULLOBJECT(e);
  *ierr = DMFieldCreateShell(*a, *b, *c, d, e);
  if (*ierr) return;
  if (! null_e && !*(void**) e) *(void **) e = (void *)-2;
}
