#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspgmresmonitorkrylov_ KSPGMRESMONITORKRYLOV
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspgmresmonitorkrylov_ kspgmresmonitorkrylov
#endif
PETSC_EXTERN void kspgmresmonitorkrylov_(KSP *a, PetscInt *b, PetscReal *c, void *d, PetscErrorCode *ierr)
{
  *ierr = KSPGMRESMonitorKrylov(*a, *b, *c, d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspgmressetcgsrefinementtype_ KSPGMRESSETCGSREFINEMENTTYPE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspgmressetcgsrefinementtype_ kspgmressetcgsrefinementtype
#endif
PETSC_EXTERN void kspgmressetcgsrefinementtype_(KSP *a, KSPGMRESCGSRefinementType *b, PetscErrorCode *ierr)
{
  *ierr = KSPGMRESSetCGSRefinementType(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspgmresgetcgsrefinementtype_ KSPGMRESGETCGSREFINEMENTTYPE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspgmresgetcgsrefinementtype_ kspgmresgetcgsrefinementtype
#endif
PETSC_EXTERN void kspgmresgetcgsrefinementtype_(KSP *a, KSPGMRESCGSRefinementType *b, PetscErrorCode *ierr)
{
  *ierr = KSPGMRESGetCGSRefinementType(*a, b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspgmressetrestart_ KSPGMRESSETRESTART
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspgmressetrestart_ kspgmressetrestart
#endif
PETSC_EXTERN void kspgmressetrestart_(KSP *a, PetscInt *b, PetscErrorCode *ierr)
{
  *ierr = KSPGMRESSetRestart(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspgmresgetrestart_ KSPGMRESGETRESTART
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspgmresgetrestart_ kspgmresgetrestart
#endif
PETSC_EXTERN void kspgmresgetrestart_(KSP *a, PetscInt *b, PetscErrorCode *ierr)
{
  CHKFORTRANNULLINTEGER(b);
  *ierr = KSPGMRESGetRestart(*a, b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspgmressethaptol_ KSPGMRESSETHAPTOL
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspgmressethaptol_ kspgmressethaptol
#endif
PETSC_EXTERN void kspgmressethaptol_(KSP *a, PetscReal *b, PetscErrorCode *ierr)
{
  *ierr = KSPGMRESSetHapTol(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspgmressetbreakdowntolerance_ KSPGMRESSETBREAKDOWNTOLERANCE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspgmressetbreakdowntolerance_ kspgmressetbreakdowntolerance
#endif
PETSC_EXTERN void kspgmressetbreakdowntolerance_(KSP *a, PetscReal *b, PetscErrorCode *ierr)
{
  *ierr = KSPGMRESSetBreakdownTolerance(*a, *b);
  if (*ierr) return;
}
