#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscpc.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define pcgamgsetnsmooths_ PCGAMGSETNSMOOTHS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define pcgamgsetnsmooths_ pcgamgsetnsmooths
#endif
PETSC_EXTERN void pcgamgsetnsmooths_(PC *a, PetscInt *b, PetscErrorCode *ierr)
{
  *ierr = PCGAMGSetNSmooths(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscpc.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define pcgamgsetaggressivelevels_ PCGAMGSETAGGRESSIVELEVELS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define pcgamgsetaggressivelevels_ pcgamgsetaggressivelevels
#endif
PETSC_EXTERN void pcgamgsetaggressivelevels_(PC *a, PetscInt *b, PetscErrorCode *ierr)
{
  *ierr = PCGAMGSetAggressiveLevels(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscpc.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define pcgamgmisksetaggressive_ PCGAMGMISKSETAGGRESSIVE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define pcgamgmisksetaggressive_ pcgamgmisksetaggressive
#endif
PETSC_EXTERN void pcgamgmisksetaggressive_(PC *a, PetscInt *b, PetscErrorCode *ierr)
{
  *ierr = PCGAMGMISkSetAggressive(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscpc.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define pcgamgsetaggressivesquaregraph_ PCGAMGSETAGGRESSIVESQUAREGRAPH
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define pcgamgsetaggressivesquaregraph_ pcgamgsetaggressivesquaregraph
#endif
PETSC_EXTERN void pcgamgsetaggressivesquaregraph_(PC *a, PetscBool *b, PetscErrorCode *ierr)
{
  *ierr = PCGAMGSetAggressiveSquareGraph(*a, *b ? PETSC_TRUE : PETSC_FALSE);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscpc.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define pcgamgmisksetmindegreeordering_ PCGAMGMISKSETMINDEGREEORDERING
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define pcgamgmisksetmindegreeordering_ pcgamgmisksetmindegreeordering
#endif
PETSC_EXTERN void pcgamgmisksetmindegreeordering_(PC *a, PetscBool *b, PetscErrorCode *ierr)
{
  *ierr = PCGAMGMISkSetMinDegreeOrdering(*a, *b ? PETSC_TRUE : PETSC_FALSE);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscpc.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define pcgamgsetlowmemoryfilter_ PCGAMGSETLOWMEMORYFILTER
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define pcgamgsetlowmemoryfilter_ pcgamgsetlowmemoryfilter
#endif
PETSC_EXTERN void pcgamgsetlowmemoryfilter_(PC *a, PetscBool *b, PetscErrorCode *ierr)
{
  *ierr = PCGAMGSetLowMemoryFilter(*a, *b ? PETSC_TRUE : PETSC_FALSE);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscpc.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define pcgamgsetgraphsymmetrize_ PCGAMGSETGRAPHSYMMETRIZE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define pcgamgsetgraphsymmetrize_ pcgamgsetgraphsymmetrize
#endif
PETSC_EXTERN void pcgamgsetgraphsymmetrize_(PC *a, PetscBool *b, PetscErrorCode *ierr)
{
  *ierr = PCGAMGSetGraphSymmetrize(*a, *b ? PETSC_TRUE : PETSC_FALSE);
  if (*ierr) return;
}
