#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define ksppipegcrsetunrollw_ KSPPIPEGCRSETUNROLLW
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define ksppipegcrsetunrollw_ ksppipegcrsetunrollw
#endif
PETSC_EXTERN void ksppipegcrsetunrollw_(KSP *a, PetscBool *b, PetscErrorCode *ierr)
{
  *ierr = KSPPIPEGCRSetUnrollW(*a, *b ? PETSC_TRUE : PETSC_FALSE);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define ksppipegcrgetunrollw_ KSPPIPEGCRGETUNROLLW
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define ksppipegcrgetunrollw_ ksppipegcrgetunrollw
#endif
PETSC_EXTERN void ksppipegcrgetunrollw_(KSP *a, PetscBool *b, PetscErrorCode *ierr)
{
  CHKFORTRANNULLBOOL(b);
  *ierr = KSPPIPEGCRGetUnrollW(*a, b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define ksppipegcrsetmmax_ KSPPIPEGCRSETMMAX
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define ksppipegcrsetmmax_ ksppipegcrsetmmax
#endif
PETSC_EXTERN void ksppipegcrsetmmax_(KSP *a, PetscInt *b, PetscErrorCode *ierr)
{
  *ierr = KSPPIPEGCRSetMmax(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define ksppipegcrgetmmax_ KSPPIPEGCRGETMMAX
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define ksppipegcrgetmmax_ ksppipegcrgetmmax
#endif
PETSC_EXTERN void ksppipegcrgetmmax_(KSP *a, PetscInt *b, PetscErrorCode *ierr)
{
  CHKFORTRANNULLINTEGER(b);
  *ierr = KSPPIPEGCRGetMmax(*a, b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define ksppipegcrsetnprealloc_ KSPPIPEGCRSETNPREALLOC
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define ksppipegcrsetnprealloc_ ksppipegcrsetnprealloc
#endif
PETSC_EXTERN void ksppipegcrsetnprealloc_(KSP *a, PetscInt *b, PetscErrorCode *ierr)
{
  *ierr = KSPPIPEGCRSetNprealloc(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define ksppipegcrgetnprealloc_ KSPPIPEGCRGETNPREALLOC
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define ksppipegcrgetnprealloc_ ksppipegcrgetnprealloc
#endif
PETSC_EXTERN void ksppipegcrgetnprealloc_(KSP *a, PetscInt *b, PetscErrorCode *ierr)
{
  CHKFORTRANNULLINTEGER(b);
  *ierr = KSPPIPEGCRGetNprealloc(*a, b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define ksppipegcrsettruncationtype_ KSPPIPEGCRSETTRUNCATIONTYPE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define ksppipegcrsettruncationtype_ ksppipegcrsettruncationtype
#endif
PETSC_EXTERN void ksppipegcrsettruncationtype_(KSP *a, KSPFCDTruncationType *b, PetscErrorCode *ierr)
{
  *ierr = KSPPIPEGCRSetTruncationType(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define ksppipegcrgettruncationtype_ KSPPIPEGCRGETTRUNCATIONTYPE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define ksppipegcrgettruncationtype_ ksppipegcrgettruncationtype
#endif
PETSC_EXTERN void ksppipegcrgettruncationtype_(KSP *a, KSPFCDTruncationType *b, PetscErrorCode *ierr)
{
  *ierr = KSPPIPEGCRGetTruncationType(*a, b);
  if (*ierr) return;
}
