#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscts.h>
#include <petscts.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define tssetposteventstep_ TSSETPOSTEVENTSTEP
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define tssetposteventstep_ tssetposteventstep
#endif
PETSC_EXTERN void tssetposteventstep_(TS *a, PetscReal *b, PetscErrorCode *ierr)
{
  *ierr = TSSetPostEventStep(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscts.h>
#include <petscts.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define tssetposteventsecondstep_ TSSETPOSTEVENTSECONDSTEP
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define tssetposteventsecondstep_ tssetposteventsecondstep
#endif
PETSC_EXTERN void tssetposteventsecondstep_(TS *a, PetscReal *b, PetscErrorCode *ierr)
{
  *ierr = TSSetPostEventSecondStep(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscts.h>
#include <petscts.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define tsseteventtolerances_ TSSETEVENTTOLERANCES
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define tsseteventtolerances_ tsseteventtolerances
#endif
PETSC_EXTERN void tsseteventtolerances_(TS *a, PetscReal *b, PetscReal c[], PetscErrorCode *ierr)
{
  CHKFORTRANNULLREAL(c);
  *ierr = TSSetEventTolerances(*a, *b, c);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscts.h>
#include <petscts.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define tsgetnumevents_ TSGETNUMEVENTS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define tsgetnumevents_ tsgetnumevents
#endif
PETSC_EXTERN void tsgetnumevents_(TS *a, PetscInt *b, PetscErrorCode *ierr)
{
  CHKFORTRANNULLINTEGER(b);
  *ierr = TSGetNumEvents(*a, b);
  if (*ierr) return;
}
